function [ freq ] = coord_symhc2_parfor( N, d )
%COORD_SYMHC2_PARFOR Computes hyperbolic cross index sets in parallel.

if ceil(N) ~= N
  error('N must be integer');
end

Nmax_array = [0 0 4096 16384 512 256 256 128 32 32];

freq = [];

if ((d <= size(Nmax_array,2)) && (N <= Nmax_array(d)))
  filename = sprintf('coord_symhc_N%d_d%d.mat',N,d);
  try
    load(filename,'freq');
    fprintf('Loading from %s\n',filename);
  catch err
  end
  if ((size(freq,1) == 0) || (size(freq,2) ~= d))
    filename = sprintf('coord_symhc_N%d_d%d.mat',Nmax_array(d),d);
    try
      load(filename,'freq');
      fprintf('Loading from %s\n',filename);
    catch err
    end
    if ((size(freq,1) > 0) && (size(freq,2) == d))
      freq = freq(prod(max(1,abs(freq)),2) <= N,:);
    end
  end
  freq = double(freq);
end

if ((size(freq,1) == 0) || (size(freq,2) ~= d))

freq = (-N:N)';

for t=2:d
  tmpweight = prod(max(1,abs(freq)),2);
  newfreq_0 = [freq, zeros(size(freq,1),1)];
  newfreq_i = cell(N,1);
  parfor newcomp = 1:N
    ind = find(tmpweight*max(1,abs(newcomp)) <= N);
    newfreq_i{newcomp} = [freq(ind,:), repmat(-newcomp, length(ind), 1); freq(ind,:), repmat(newcomp, length(ind), 1)];
  end
  freq = [newfreq_0; cell2mat(newfreq_i)];
end

end

end

