function [ N_array_out, sizeH_array_out, M_array_out, val2_matrix, val1_matrix, lattices_out ] = testG3_dmr1l_symhceven_fulllattice1_results( d )
%TESTG3_DMR1L_SYMHCEVEN_FULLLATICE1_RESULTS Computes the error in using a series of multiple rank-1 lattices for approximation on even hyperbolic crosses starting with exponential lattices for the full grid.

load(sprintf('test_mr1l_approx_symhceven_fulllattice1_d%d.mat', d), 'results');

filename_out = sprintf('testG3_dmr1l_symhceven_fulllattice1_results_d%d.mat', d);

N_array_out = [];
sizeH_array_out = [];
M_array_out = [];
val2_matrix = [];
val1_matrix = [];
lattices_out = struct([]);

for iN = 1:length(results)
  N = results{iN}.N;
  freq = coord_symhc2even(N,d);
  nfreq = size(freq,1);
  if nfreq ~= results{iN}.num_freq
    error('freq size mismatch');
  end

  N_I = max(max(freq,[],1)-min(freq,[],1)+1);
  M = N_I^d;
  result.num_freq = size(freq,1);
  fprintf('N=%d, d=%d, s=%d, M=%g, ', N, d, result.num_freq, M);

  Ms = results{iN}.Ms;
  zs = ones(length(Ms), d);

  if (N_I^(d-1) > 2^62) || (max(sum(abs(freq),2))*N_I^(d-1) > 2^62)
    for t=2:d
      for ii=1:t-1
        for l=1:length(Ms)
          zs(l,t) = mod(zs(l,t) * N_I, Ms(l));
        end
      end
    end
    fprintf('z large, ');
  else
    for l=1:length(Ms)
      zs(l,:) = mod(N_I.^(0:d-1), Ms(l));
    end
  end

  lattices_out(iN).zs = zs;
  lattices_out(iN).Ms = Ms;

  [ val2, val2_truncerr, val2_aliaserr, val1, val1_truncerr, val1_aliaserr ] = testG3_mlfft2_run( freq, zs, Ms );
  fprintf('d=%d, N=%d, sizeH=%d, M=%d: err2=%.3e (t %.3e | a %.3e), err1=%.3e (t %.3e | a %.3e)\n', d, N, nfreq, sum(Ms), val2, val2_truncerr, val2_aliaserr, val1, val1_truncerr, val1_aliaserr);
  drawnow;
  N_array_out = [N_array_out; N];
  sizeH_array_out = [sizeH_array_out; nfreq];
  M_array_out = [M_array_out; sum(Ms)-length(Ms)+1];
  val2_matrix = [val2_matrix; val2, val2_truncerr, val2_aliaserr];
  val1_matrix = [val1_matrix; val1, val1_truncerr, val1_aliaserr];
  
  save(filename_out, 'N_array_out', 'sizeH_array_out', 'M_array_out', 'val2_matrix', 'val1_matrix', 'lattices_out');
end

end

